--[[----------------------------------------------------------------------------

ADOBE CONFIDENTIAL
------------------
Copyright 2016 Adobe Systems Incorporated
All Rights Reserved.

NOTICE: All information contained herein is, and remain the property of
Adobe Systems Incorporated and its suppliers, if any. The intellectual and
technical concepts contained herein are proprietary to Adobe Systems
Incorporated and its suppliers and may be covered by U.S. and Foreign
Patents, patents in process, and are protected by trade secret or copyright
law.  Dissemination of this information or reproduction of this material is
strictly forbidden unless prior written permission is obtained from
Adobe Systems Incorporated.

----------------------------------------------------------------------------]]--

	-- WF.core.utils
local WFArguments = require 'WFArguments'

--==============================================================================

-- @mark LrmConfig namespace

--------------------------------------------------------------------------------

local LrmConfig = {}

--------------------------------------------------------------------------------

local kStrategyPreferProxy = 'preferProxy'
local kStrategyPreferMaster = 'preferMaster'
local kStrategyProxy = 'proxy'
local kStrategyMaster = 'master'
local kStrategyProxyAndMaster = 'proxyAndMaster'

--------------------------------------------------------------------------------

LrmConfig.StrategyPreferProxy = kStrategyPreferProxy
LrmConfig.StrategyPreferMaster = kStrategyPreferMaster
LrmConfig.StrategyProxy = kStrategyProxy
LrmConfig.StrategyMaster = kStrategyMaster
LrmConfig.StrategyProxyAndMaster = kStrategyProxyAndMaster

--------------------------------------------------------------------------------

function LrmConfig.registerBinaryStrategyCheck()

	WFArguments.unregisterChecker( 'binaryStrategy' )
	
	WFArguments.registerChecker( 'binaryStrategy', function( strategy )
		return type( strategy ) == 'string' and
			strategy == LrmConfig.StrategyPreferMaster or
			strategy == LrmConfig.StrategyPreferProxy or
			strategy == LrmConfig.StrategyMaster or
			strategy == LrmConfig.StrategyProxy or
			strategy == LrmConfig.StrategyProxyAndMaster

	end )
	
end

--------------------------------------------------------------------------------

return LrmConfig
